> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List report controls

GET https://api.sigmacomputing.com/v2/reports/{reportId}/controls

This endpoint retrieves all control elements within a specific report. Control elements provide predefined interactions to users viewing a report, such as inputs that modify data or selections to filter data.

### Usage notes
- Retrieve the **reportId** by calling the [/v2/reports](https://help.sigmacomputing.com/reference/list-reports) endpoint.

### Usage scenarios
- **Dynamic data interaction:** Allows users to interact dynamically with the data presented in the report through various control mechanisms.
- **Custom reporting:** Enables the creation of customizable reports where end users can adjust parameters to filter and sort data according to their requirements.

### Best practices
- Ensure proper access controls are set to manage who can view or interact with the controls to prevent unauthorized data manipulation.
- Use detailed and descriptive names for controls to facilitate easier identification and use by end users.

Reference: https://help.sigmacomputing.com/reference/list-report-controls

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/reports/{reportId}/controls:
    get:
      operationId: listReportControls
      summary: List report controls
      description: >-
        This endpoint retrieves all control elements within a specific report.
        Control elements provide predefined interactions to users viewing a
        report, such as inputs that modify data or selections to filter data.


        ### Usage notes

        - Retrieve the **reportId** by calling the
        [/v2/reports](https://help.sigmacomputing.com/reference/list-reports)
        endpoint.


        ### Usage scenarios

        - **Dynamic data interaction:** Allows users to interact dynamically
        with the data presented in the report through various control
        mechanisms.

        - **Custom reporting:** Enables the creation of customizable reports
        where end users can adjust parameters to filter and sort data according
        to their requirements.


        ### Best practices

        - Ensure proper access controls are set to manage who can view or
        interact with the controls to prevent unauthorized data manipulation.

        - Use detailed and descriptive names for controls to facilitate easier
        identification and use by end users.
      tags:
        - Reports
      parameters:
        - name: reportId
          in: path
          required: true
          schema:
            type: string
        - name: pageToken
          in: query
          required: false
          schema:
            type: string
        - name: pageSize
          in: query
          required: false
          schema:
            type: integer
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/reports_listReportControls_Response_200'
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType0:
      type: string
      enum:
        - boolean
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType0
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType1:
      type: string
      enum:
        - number
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType1
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType2:
      type: string
      enum:
        - text
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType2
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType3:
      type: string
      enum:
        - date
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType3
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType4:
      type: string
      enum:
        - number-list
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType4
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType5:
      type: string
      enum:
        - text-list
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType5
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType6:
      type: string
      enum:
        - date-list
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType6
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType7:
      type: string
      enum:
        - boolean-list
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType7
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType8:
      type: string
      enum:
        - date-range
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType8
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType9:
      type: string
      enum:
        - number-range
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType9
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType10:
      type: string
      enum:
        - date-null
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType10
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType11:
      type: string
      enum:
        - number-null
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType11
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType12:
      type: string
      enum:
        - text-null
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType12
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType13:
      type: string
      enum:
        - boolean-null
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType13
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType:
      oneOf:
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType0
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType1
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType2
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType3
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType4
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType5
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType6
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType7
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType8
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType9
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType10
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType11
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType12
        - $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType13
      description: Value of the control
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType
    V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItems:
      type: object
      properties:
        name:
          type: string
        valueType:
          $ref: >-
            #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType
          description: Value of the control
      required:
        - name
        - valueType
      title: >-
        V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItems
    reports_listReportControls_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2ReportsReportIdControlsGetResponsesContentApplicationJsonSchemaEntriesItems
          description: Array of results returned by the endpoint
        nextPageToken:
          type: string
          description: >-
            A string that can be passed to the `pageToken` parameter in the next
            request to fetch the next page of results. Not present in the last
            page of results.

            **Must be treated as an opaque string.**
      required:
        - entries
      title: reports_listReportControls_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Response**

```json
{
  "entries": [
    {
      "name": "string",
      "valueType": "boolean"
    }
  ],
  "nextPageToken": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/reports/reportId/controls"

headers = {"Authorization": "<token>."}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/reports/reportId/controls';
const options = {method: 'GET', headers: {Authorization: '<token>.'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/reports/reportId/controls"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<token>.")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/reports/reportId/controls")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/reports/reportId/controls")
  .header("Authorization", "<token>.")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/reports/reportId/controls', [
  'headers' => [
    'Authorization' => '<token>.',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/reports/reportId/controls");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "<token>."]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/reports/reportId/controls")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```